<?php




class YSPEECHETFTEC_Style
{
    public function __construct()
    {
        add_filter('tribe_template_path_list', array($this, 'yspeechetftec_filter_template_path_list'), 15, 2);
        add_action(
            'tribe_template_after_include:events/v2/list/event/title',
            function ($file, $name, $template) {
                $template->template('list/event-target-group');
            },
            10,
            3
        );
        add_action(
            'tribe_events_single_event_after_the_meta',
            array($this, 'yspeechetftec_advanced_event_details'),
            10,
            3
        );
    }

    public function yspeechetftec_advanced_event_details()
    {
        $event_id = get_the_ID();

        if (file_exists(dirname(__FILE__) . '/yspeechetftec-views-helper.php')) {
            require_once dirname(__FILE__) . '/yspeechetftec-views-helper.php';
        }

        $feedback_link = yspeechetftec_get_event_feedback_link($event_id);
        $feedback_link_title = yspeechetftec_get_event_feedback_link_title($event_id);
        $target_group = yspeechetftec_get_event_target_group($event_id);
        $target_group_title = yspeechetftec_get_event_target_group_title($event_id);
?>
        <div class="tribe-events-single-section tribe-events-event-meta primary tribe-clearfix">
            <div class="tribe-events-meta-group tribe-events-meta-group-details">
                <h2 class="tribe-events-single-section-title"> <?php esc_html_e('Weitere Infos', 'yspeechetftec'); ?> </h2>
                <dl>
                    <?php
                    // Event Feedback
                    if (!empty($feedback_link)) : ?>
                        <?php if (!empty($feedback_link_title)) : ?>
                            <dt class="tribe-events-event-url-label"> <strong><?php echo esc_html($feedback_link_title); ?></strong> </dt>
                        <?php endif; ?>
                        <dd class="tribe-events-event-url"> <?php echo $feedback_link; ?> </dd>
                    <?php endif ?>

                    <?php
                    // Event Target Group
                    if (!empty($target_group)) : ?>
                        <?php if (!empty($target_group_title)) : ?>
                            <dt class="tribe-events-event-url-label"> <strong><?php echo esc_html($target_group_title); ?></strong> </dt>
                        <?php endif; ?>
                        <dd class="tribe-events-event-url"> <?php echo $target_group; ?> </dd>
                    <?php endif ?>

                </dl>
            </div>
        </div>
<?php
    }


    /**
     * Filters the list of folders TEC will look up to find templates to add the ones defined by Filter Bar.
     *
     * @since 5.0.0
     *
     * @param array            $folders  The current list of folders that will be searched template files.
     * @param \Tribe__Template $template Which template instance we are dealing with.
     *
     * @return array<string,array> The filtered list of folders that will be searched for the templates.
     */
    public function yspeechetftec_filter_template_path_list(array $folders = [], \Tribe__Template $template = null)
    {
        $path = (array) rtrim(trailingslashit(YSPEECHETFTEC_PLUGIN_DIR), '/');

        // Pick up if the folder needs to be added to the public template path.
        $folder = $template->get_template_folder();

        if (!empty($folder)) {
            $path = array_merge($path, $folder);
        }

        $folders['yspeechetftec'] = [
            'id'        => 'yspeechetftec',
            'namespace' => 'yspeechetftec',
            'priority'  => 5,
            'path'      => implode(DIRECTORY_SEPARATOR, $path),
        ];

        return $folders;
    }
}

new YSPEECHETFTEC_Style;
